com.fasterxml.jackson.databind.deser.impl

## Class TypeWrappedDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<Object>
  - - com.fasterxml.jackson.databind.deser.impl.TypeWrappedDeserializer

All Implemented Interfaces:
  NullValueProvider, Serializable

    public final class TypeWrappedDeserializer
    extends JsonDeserializer<Object>
    implements Serializable

Simple deserializer that will call configured type deserializer, passing in configured data deserializer, and exposing it all as a simple deserializer. This is necessary when there is no "parent" deserializer which could handle details of calling a `TypeDeserializer`, most commonly used with root values.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected JsonDeserializer<Object>` `_deserializer`
`protected TypeDeserializer` `_typeDeserializer`

### Constructor Summary

Constructors
Constructor and Description
`TypeWrappedDeserializer(TypeDeserializer typeDeser, JsonDeserializer<?> deser)`

### Method Summary

All Methods Instance Methods Concrete Methods
`Object` `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` `deserialize(JsonParser p, DeserializationContext ctxt, Object intoValue)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.
`JsonDeserializer<?>` `getDelegatee()` Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls.
`Object` `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`Collection<Object>` `getKnownPropertyNames()` Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name.
`Object` `getNullValue(DeserializationContext ctxt)` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
`Class<?>` `handledType()` Method for accessing type of values this deserializer produces.
`Boolean` `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`findBackReference, getEmptyAccessPattern, getEmptyValue, getNullAccessPattern, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _typeDeserializer

    protected final TypeDeserializer _typeDeserializer

#### _deserializer

    protected final JsonDeserializer<Object> _deserializer

### Constructor Detail

#### TypeWrappedDeserializer

    public TypeWrappedDeserializer(TypeDeserializer typeDeser,
                                   JsonDeserializer<?> deser)

### Method Detail

#### handledType

    public Class<?> handledType()

Description copied from class: `JsonDeserializer`
Method for accessing type of values this deserializer produces. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

Default implementation will return null, which means almost same same as returning `Object.class` would; that is, that nothing is known about handled type.

Overrides:
  `handledType` in class `JsonDeserializer<Object>`

#### supportsUpdate

    public Boolean supportsUpdate(DeserializationConfig config)

Description copied from class: `JsonDeserializer`
Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserialization construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

Default implementation returns `null` to allow explicit per-type or per-property attempts.

Overrides:
  `supportsUpdate` in class `JsonDeserializer<Object>`

#### getDelegatee

    public JsonDeserializer<?> getDelegatee()

Description copied from class: `JsonDeserializer`
Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls. If so, will return immediate delegate (which itself may delegate to further deserializers); otherwise will return null.

Overrides:
  `getDelegatee` in class `JsonDeserializer<Object>`
Returns:
  Deserializer this deserializer delegates calls to, if null; null otherwise.

#### getKnownPropertyNames

    public Collection<Object> getKnownPropertyNames()

Description copied from class: `JsonDeserializer`
Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name. This is only to be used for error reporting and diagnostics purposes (most commonly, to accompany "unknown property" exception).

Overrides:
  `getKnownPropertyNames` in class `JsonDeserializer<Object>`

#### getNullValue

    public Object getNullValue(DeserializationContext ctxt)
                        throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

Since version 2.6 (in which the context argument was added), call is expected to be made each and every time a null token needs to be handled.

Default implementation simply returns null.

Specified by:
  `getNullValue` in interface `NullValueProvider`
Overrides:
  `getNullValue` in class `JsonDeserializer<Object>`
Throws:
  `JsonMappingException`

#### getEmptyValue

    public Object getEmptyValue(DeserializationContext ctxt)
                         throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for types. Or, if type should never be converted from empty String, method can also throw an exception.

Since version 2.6 (in which the context argument was added), call is expected to be made each and every time an empty value is needed.

Since version 2.9 does not require return of `T` any more.

Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Overrides:
  `getEmptyValue` in class `JsonDeserializer<Object>`
Throws:
  `JsonMappingException`

#### deserialize

    public Object deserialize(JsonParser p,
                              DeserializationContext ctxt)
                       throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.getCurrentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException

Description copied from class: `JsonDeserializer`
Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

Overrides:
  `deserializeWithType` in class `JsonDeserializer<Object>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`

#### deserialize

    public Object deserialize(JsonParser p,
                              DeserializationContext ctxt,
                              Object intoValue)
                       throws IOException

Description copied from class: `JsonDeserializer`
Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

Overrides:
  `deserialize` in class `JsonDeserializer<Object>`
Throws:
  `IOException`